#INCLUDE "dcdialog.CH"

*#INCLUDE "xbppack2.CH"
#define XBPPRGR_ORIENT_HORIZONTAL   XBP_ORIENT_HORIZONTAL
#define XBPPRGR_ORIENT_VERTICAL     XBP_ORIENT_VERTICAL

#define XBPPRGR_STYLE_NORMAL        0
#define XBPPRGR_STYLE_SMOOTH        1
#define XBPPRGR_STYLE_MARQUEE       8

#define XBPPRGR_STATE_NORMAL        1
#define XBPPRGR_STATE_ERROR         2
#define XBPPRGR_STATE_PAUSED        3

#pragma Library("DCLIP1.LIB")

FUNCTION Main()

LOCAL GetList[0]

// MARQUEE under Construction ( will hang ??? )
//
@ 0,0 DCPUSHBUTTON CAPTION 'Standard Please Wait Progress Bar' ;
      SIZE 40,2 ACTION {||PleaseWait( 5 )}

// @ 2,0 DCPUSHBUTTON CAPTION 'Backup Files Progress Bar' ;
//       SIZE 40,2 ACTION {||Backup(.f.)}

@ 4,0 DCPUSHBUTTON CAPTION 'Backup Files Progress Bar (w/cancel button)' ;
      SIZE 40,2 ACTION {||Backup(.t.)}


// @ 6,0 DCPUSHBUTTON CAPTION 'Reindex Files Progress Bar' ;
//       SIZE 40,2 ACTION {||Reindex(.f.)}
//
// @ 8,0 DCPUSHBUTTON CAPTION 'Reindex Files Progress Bar (w/cancel button)' ;
//       SIZE 40,2 ACTION {||Reindex(.t.)}

DCREAD GUI FIT TITLE 'Progress Bars' SETAPPWINDOW

RETURN nil

* -------------

FUNCTION PleaseWait( nSeconds )

LOCAL oProgress, i

DEFAULT nSeconds := 2

oProgress := WaitProgress():new()
oProgress:messageString := 'Doing some stuff. Please Wait...'
oProgress:title := 'Doing Stuff'
oProgress:progressStyle := XBPPRGR_STYLE_MARQUEE
oProgress:create()

#IFDEF DXE
   oProgress:SetNewStyle( XBPPRGR_STYLE_MARQUEE )
#ENDIF

FOR i := 1 TO nSeconds * 10
#IFDEF DXE
*   oProgress:setData( nSeconds * 10 )
    oProgress:setData(1)
#ENDIF
  DC_CompleteEvents() // need this to move window
  Sleep(10)
NEXT
oProgress:destroy()

RETURN nil

* -------------

FUNCTION Backup( lCancelButton )

LOCAL oProgress, aDir, i, j

DEFAULT lCancelButton := .f.

oProgress := WaitProgress():new()
oProgress:messageString := 'Backing up files. Please Wait...'
oProgress:title := 'File Backup'
oProgress:isCancelButton := lCancelButton
oProgress:progressStyle := XBPPRGR_STYLE_SMOOTH
oProgress:create()

#IFDEF DXE
*   oProgress:progressObject:Style := XBPPRGR_STYLE_SMOOTH
*   oProgress:SetNewStyle(XBPPRGR_STYLE_SMOOTH)
#ENDIF

aDir := Directory()
FOR i := 1 TO Len(aDir)
  oProgress:setData(0)
  oProgress:statusObject:setCaption(aDir[i,1])
  oProgress:progressObject:maximum := aDir[i,2]
  FOR j := 1 TO aDir[i,2] STEP 200 // need this to move window
    oProgress:setData( j )
    DC_CompleteEvents()
    IF oProgress:isCancelled
      EXIT
    ENDIF
  NEXT
  IF oProgress:isCancelled
    EXIT
  ENDIF
NEXT

oProgress:destroy()

RETURN nil

* -------------

FUNCTION Reindex( lCancelButton )

LOCAL oProgress, aIndex, i, j, cDatabase, cIndexKey, cTagName, nRecords, ;
      nCount, cDbe, bIndexKey

DC_LoadRdds()

DEFAULT lCancelButton := .f.

oProgress := WaitProgress():new()
oProgress:messageString := 'Reindexing files. Please Wait...'
oProgress:title := 'Reindexing Files'
oProgress:isCancelButton := lCancelButton

oProgress:create()

aIndex := { ;
   { 'XTEST', 'FOXCDX', ;
     { {'AREACODE', 'AREACODE' }, ;
       {'EXCHANGE', 'EXCHANGE' }, ;
       {'NUMBER', 'NUMBER'}, ;
       {'CITY', 'CITY' } } }, ;
   { 'CUSTOMER', 'FOXCDX', ;
     { { 'CUSTOMER', 'CUST_NMBR'}, ;
       { 'CUST_NMBR', 'CUST_NMBR'}, ;
       { 'BILL_NAME','Upper(BILL_NAME)'}, ;
       { 'CUST_CODE','CUST_CODE'}, ;
       { 'BILL_CITY','Upper(BILL_CITY)'}, ;
       { 'PHONE', 'PHONE'}, ;
       { 'CONTACT', 'CONTACT'} } }, ;
   { 'HELP', 'FOXCDX', ;
     { {'HELP_CODE', 'HELP_CODE' }, ;
       {'HELP_SORT', 'SORT' } } } ;
   }

FOR i := 1 TO LEN(aIndex)
  cDatabase := aIndex[i,1]
  cDbe := aIndex[i,2]
  SET DEFAULT TO ..\..\data
  FErase( '..\..\' + cDatabase + '.CDX' )
  USE (cDatabase) VIA (cDbe) EXCLUSIVE
  nRecords := (cDatabase)->(RecCount())
  oProgress:progressObject:maximum := nRecords
  FOR j := 1 TO Len(aIndex[i,3])
    nCount := 0
    cTagName := aIndex[i,3,j,1]
    cIndexKey := aIndex[i,3,j,2]
    oProgress:setData(0)
    oProgress:statusObject:setCaption('File: ' + cDatabase + '  Tag:' + cTagName)

    bIndexKey := {||IIF(nCount%50==0,DC_CompleteEvents(),nil), ;
                    nCount++,oProgress:setData(nCount),&cIndexKey}

    OrdSetFocus(0)
    OrdCreate( cDatabase, cTagName, cIndexKey, bIndexKey, .f., .f. )

    IF oProgress:isCancelled
      EXIT
    ENDIF

  NEXT
  IF oProgress:isCancelled
    EXIT
  ENDIF
NEXT

oProgress:destroy()

RETURN nil



* -----------

CLASS WaitProgress

EXPORTED:

VAR messageObject
VAR messageString
VAR messageFont
VAR statusObject
VAR statusString
VAR statusFont
VAR threadObject
VAR threadInterval
VAR isCancelled
VAR isComplete
VAR getList
VAR evalBlock
VAR progressStaticObject
VAR progressObject
VAR progressInterval
VAR progressStyle
VAR progressMinimum
VAR progressMaximum
VAR progressWidth
VAR progressHeight
VAR progressPause
VAR progressError
VAR title
VAR dialogWindow
VAR isCancelButton

METHOD Init, Create, Destroy, Start, Interval, SetData, GetData
METHOD SetNewState,SetNewStyle

ENDCLASS

* ----------

METHOD WaitProgress:Init()

::messageString := 'Please wait...'
::messageFont := '10.Lucida Console'
::statusString := ''
::statusFont := '10.Lucida Console'
::isCancelled := .f.
::isComplete := .f.
::progressWidth := 350
::progressMinimum := 0
::progressMaximum := 200

::progressStyle   := XBPPRGR_STYLE_NORMAL
*::progressPause   :=  0
*::progressError   :=  0
::threadInterval  := nil
::isCancelButton  := .f.

RETURN self

* ----------

METHOD WaitProgress:Create()

LOCAL GetList[0], GetOptions

::getList := GetList

@ 0,0 DCSAY ::messageString SAYSIZE 0 FONT ::messageFont

@ 20,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE ::progressWidth, 20 COLOR nil, GRA_CLR_WHITE ;
      OBJECT ::progressStaticObject

@ 40,0 DCSAY ::statusString SAYSIZE ::progressWidth, 20 FONT ::statusFont OBJECT ::statusObject

IF ::isCancelButton

  @ 60,0 DCPUSHBUTTON CAPTION {||IIF(::isComplete,'Exit','Cancel')} SIZE 60,20 ;
        ACTION {||::isCancelled := .t., DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

ENDIF

DCGETOPTIONS PIXEL

DCREAD GUI FIT EXIT TITLE ::title EVAL {|o|::dialogWindow := o} ;
   OPTIONS GetOptions MODAL

::Start()

RETURN self

* -----------

METHOD WaitProgress:destroy()

::threadObject:SetInterval( nil )
::dialogWindow:destroy()

RETURN self

* -----------

METHOD WaitProgress:Start()

LOCAL oThread

#IFDEF DXE
   ::progressObject := DXE_ProgressBar():New( ::progressStaticObject,, {0,0}, ::progressStaticObject:currentSize() )
#ELSE
   IF !IsFunction("XbpProgressBar")
      DllLoad('xbppack2.dll')
   ENDIF
   ::progressObject := &('XbpProgressBar()')
   ::progressObject := ::progressObject:New( ::progressStaticObject,, {0,0}, ::progressStaticObject:currentSize() )

*  ::progressObject := XbpProgressBar():New( ::progressStaticObject,, {0,0}, ::progressStaticObject:currentSize() )
#ENDIF

::progressObject:UseVisualStyle := .t.
::progressObject:Create()

::progressObject:Minimum := ::progressMinimum
::progressObject:Maximum := ::progressMaximum
::progressObject:Style   := ::progressStyle
*::progressObject:State   := XBPPRGR_STATE_NORMAL

::progressObject:SetData( 0 )

::threadObject := Thread():New()
::threadObject:SetInterval( ::threadInterval )
::threadObject:Start( {|| ::Interval()} )

RETURN .t.

* ---------

METHOD WaitProgress:Interval()

LOCAL nValue := ::progressObject:GetData()

nValue++

IF nValue >= ::progressObject:Maximum
   nValue := ::progressObject:Minimum
ENDIF

::progressObject:SetData( nValue )

RETURN

* ----------

METHOD WaitProgress:setData( nValue )

RETURN ::progressObject:setData( nValue )

* ----------

METHOD WaitProgress:getData()

RETURN ::progressObject:getData()

* ----------

METHOD WaitProgress:SetNewState( nValue )
/*
   XBPPRGR_STATE_NORMAL
   XBPPRGR_STATE_PAUSED
   XBPPRGR_STATE_ERROR
*/

   ::progressObject:State := nValue
RETURN


METHOD WaitProgress:SetNewStyle( nValue )
/*
   XBPPRGR_STYLE_NORMAL
   XBPPRGR_STYLE_SMOOTH
   XBPPRGR_STYLE_MARQUEE
*/
   ::progressStyle        := nValue
   ::progressObject:Style := nValue

RETURN

PROCEDURE AppSys() ; RETURN
*
* eof
*