#include "DCDIALOG.CH"

PROCEDURE MAIN
LOCAL i,j

FOR j = 1 TO 4
   ProgressBar(0,,100,j)
   FOR i := 1 TO 100
     Sleep(5)
     ProgressBar(1,i,100,j)
   NEXT
NEXT
Sleep(1)

DCMSGBOX 'Stop'
ProgressBar(2)

RETURN

* ---------------

PROC appsys ; RETURN

* ---------------

FUNCTION ProgressBar( nMode, nCount, nMaxCount, nZebra )

STATIC oProgress, oDialog

LOCAL GetList[0], GetOptions

DEFAULT nCount    := 0 ,;
        nMaxCount := 0 ,;
        nZebra    := 0

IF nMode == 0

  IF Valtype(oProgress) = 'O' .AND. oProgress:status() > 0
    oDialog:destroy()
    oDialog := nil
    oProgress := nil
  ENDIF

  @ 0,0 DCPROGRESS oProgress ;
        TYPE XBPSTATIC_TYPE_TEXT ;
        MAXCOUNT nMaxCount ;
        PERCENT ;
        PERCENTCOLOR GRA_CLR_RED ;
        FONT '12.Arial Bold' ;
        EVERY 1 ;
        COLOR GRA_CLR_CYAN, GRA_CLR_BACKGROUND ;
        SIZE 300,20 ;
        PIXEL ;
        RADIUS 20 ;
        OUTLINE ;
        DYNAMIC ;
        SUBCLASS 'MyProgressBar()'

  DCGETOPTIONS ;
     NOTITLEBAR ;
     FITPAD 5

  DCREAD GUI ;
     FIT ;
     OPTIONS GetOptions ;
     PARENT @oDialog ;
     EXIT ;
     NOAUTORESTORE ;
     MODAL ;
     SETAPPWINDOW

     // only hide Child -> see GRA on Parent
     //
     IF nZebra % 2 == 0
        oProgress:HideIt()                          // o:ShowIt()
     ENDIF

ELSEIF nMode = 1

  DC_GetProgress(oProgress,nCount,nMaxCount)

ELSEIF nMode = 2

  IF Valtype(oProgress) = 'O' .AND. oProgress:status() > 0
    oDialog:setModalState(XBP_DISP_MODELESS)
    oDialog:destroy()
    oDialog := nil
    oProgress := nil
  ENDIF

ENDIF

RETURN nil

* ------------

CLASS MyProgressBar FROM DXE_ProgressBar, DC_XbaseParts

EXPORTED:

  VAR barColor
  VAR backColor
  VAR optionArray
  VAR presSpace
  VAR percentFont
  VAR percentColor
  VAR radius
  VAR outline
  VAR dynamic
  METHOD init, create

ENDCLASS

* ------------------

METHOD MyProgressBar:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, aColor, aGetList, aGetListItem

::DXE_ProgressBar:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::tabstop  := .F.
::vertical := .F.
::percent  := .F.
::barColor := GRA_CLR_BLUE
::backColor := GRA_CLR_BACKGROUND
::percentColor := GRA_CLR_WHITE
::percentFont := '8.Arial Bold'

IF Valtype(oGetList) == 'O'

  ::DC_XbaseParts:init( oGetList,,self )

  aGetList := ::getList:getListArray
  aGetListItem := ::getList:getListArray[::getListPointer]

  xOptions := aGetListItem[xGETLIST_OPTIONS]

  IF Valtype(aGetListItem[nGETLIST_SUBTYPE]) = 'N'
    ::type := aGetListItem[nGETLIST_SUBTYPE]
  ELSE
    ::type := XBPSTATIC_TYPE_RAISEDBOX
  ENDIF

  ASize(xOptions,4)

  DEFAULT xOptions[1] := 1
  DEFAULT xOptions[2] := .f.  // Show Percentage box
  DEFAULT xOptions[3] := 1
  DEFAULT xOptions[4] := .f.  // Vertical
  IF xOptions[3] <= 0
    xOptions[3] := 1
  ENDIF

  ::optionArray := xOptions

  aColor := aGetListItem[aGETLIST_COLOR]
  IF Valtype(aColor) = 'B'
    aColor := Eval(aColor)
  ENDIF
  IF Valtype(aColor) = 'N'
    aColor :=  { aColor, GRA_CLR_PALEGRAY }
  ELSEIF Valtype(aColor) = 'A'
    ASize(aColor,2)
  ELSE
    aColor := { GRA_CLR_DARKBLUE, GRA_CLR_PALEGRAY }
  ENDIF
  DEFAULT aColor[1] := GRA_CLR_DARKBLUE, ;
          aColor[2] := GRA_CLR_PALEGRAY

  ::every         := Int(xOptions[3])
  ::barColor      := aColor[1]
  ::backColor     := aColor[2]
  ::vertical      := xOptions[4]

// work in DXE as
//
// ACCESS METHOD DC_GetMaximum() VAR maxCount
// ASSIGN METHOD DC_SetMaximum() VAR maxCount
//
  ::maxCount      := xOptions[1]                 // -> DXE

  ::percent       := ::optionArray[2]
  ::percentFont   := aGetListItem[cGETLIST_FONT]
  ::percentColor  := aGetListItem[xGETLIST_OPTIONS2]
  ::radius        := aGetListItem[xGETLIST_OPTIONS3]
  ::dynamic       := aGetListItem[xGETLIST_OPTIONS4]
  ::outline       := aGetListITem[xGETLIST_OPTIONS5]

  ::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
  IF Valtype( bBlock ) = 'B'
    Eval( bBlock, self )
  ENDIF

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
  IF Valtype(bBlock) = 'B'
    Eval( bBlock, self )
  ENDIF

ENDIF

// work in DXE as
//
// ASSIGN METHOD DC_SetData() VAR currCount
// ACCESS METHOD DC_GetData() VAR currCount
//
::currCount       := 0                           // -> DXE

::clipChildren    := .t.

DEFAULT ::outline := .F., ;
        ::dynamic := .F.

IF Valtype(::percentColor) = 'B'
  ::percentColor := Eval(::percentColor)
ENDIF

#IFDEF DXE
   // default XBP_ORIENT_HORIZONTAL
   ::vertical    := xOptions[4]
   IF ::vertical == .T.
      ::nOrientation := XBP_ORIENT_VERTICAL
   ENDIF
#ENDIF

RETURN self

* --------------------

METHOD MyProgressBar:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL nWidth, nHeight, oPS, oFont

 ::DXE_ProgressBar:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

   IF !Empty(::percentFont)
      ::presSpace := ::lockPS()
     IF Valtype(::percentfont) == 'C'
       oFont := GraSetFont(::presSpace)
       oFont := DC_FontConfigure( oFont, ::percentFont, nil, ::presSpace )
       GraSetFont( ::presSpace, oFont )
     ELSEIF Valtype(::percentFont) == 'O'
       GraSetFont( ::presSpace, ::percentFont )
     ENDIF
   ENDIF

   ::DC_XbaseParts:setOrig(self)

   ::paint := {||DC_GetProgress(self,::currCount,::maxCount)}

RETURN self
